import package, codecs, os, cStringIO, plistlib

def getEncoding(bom):
    if bom.startswith(codecs.BOM_UTF32):
        return 'utf_32'
    elif bom.startswith(codecs.BOM_UTF32_BE):
        return 'utf_32_be'
    elif bom.startswith(codecs.BOM_UTF32_LE):
        return 'utf_32_le'
    elif bom.startswith(codecs.BOM_UTF8):
        return 'utf_8_sig'
    elif bom.startswith(codecs.BOM):
        return 'utf_16'
    elif bom.startswith(codecs.BOM_BE):
        return 'utf_16_be'
    elif bom.startswith(codecs.BOM_LE):
        return 'utf_16_le'
    elif bom.startswith(codecs.BOM_UTF16):
        return 'utf_16'
    elif bom.startswith(codecs.BOM_UTF16_BE):
        return 'utf_16_be'
    elif bom.startswith(codecs.BOM_UTF16_LE):
        return 'utf_16_le'
    return 'utf_8'

savePrefix = "/Users/impiaaa/Desktop/achievements/"
def writeXML(fname, encoding, achievements, prefix):
    fout = codecs.open(savePrefix+fname, 'w', encoding)
    fout.write("<achievements>\n")
    for achievement in achievements.itervalues():
        fout.write("<achievement>\n")
        fout.write("<id>%s!0x%08x</id>\n" % (prefix, achievement["id"]))
        fout.write("<name>%s</name>\n" % achievement["name"])
        fout.write("<description>%s</description>\n" % achievement["description"])
        fout.write("</achievement>\n")
    fout.write("</achievements>")
    fout.close()

def writePlist(fname, achievements, prefix):
    newAchievements = {}
    for achievement in achievements.itervalues():
        newId = achievement.pop("id")
        newId = '%s!0x%08x' % (prefix, newId)
        newAchievements[newId] = achievement
    plistlib.writePlist(newAchievements, savePrefix+fname)

basedir = "/Applications/Games/Simulation & Sports/SPORE/SPORE.app/Contents/Resources/transgaming/c_drive/Spore/Data/Locale/"
titles = [0x0770B817,
          0x0770B81D,
          0x0770B835,
          0x0770B82D,
          0x0770B855,
          0x0770B81F,
          0x0770B839,
          0x0770B843,
          0x0770B819,
          0x0770B841,
          0x0770B849,
          0x0770B84B,
          0x0770B847,
          0x0770B84D,
          0x0770B845,
          0x0770B83D,
          0x0770B80F,
          0x0770B827,
          0x0770B807,
          0x0770B809,
          0x0770B85B,
          0x0770B83B,
          0x0770B825,
          0x0770B815,
          0x0770B80D,
          0x0770B813,
          0x0770B83F,
          0x07F46070,
          0x0770B811,
          0x0770B82B,
          0x0770B851,
          0x0770B837,
          0x0770B859,
          0x0770B831,
          0x0770B823,
          0x0770B80B,
          0x0770B803,
          0x0770B821,
          0x07C8FCEA,
          0x0770B800,
          0x0770B829,
          0x0770B81B,
          0x0770B853,
          0x07C8FC37,
          0x0770B84F,
          0x0770B857,
          0x0770B833,
          0x0770B805,
          0x0770B82F]
langs = {0xFD7D924C: "ru-ru",
         0x58D931D0: "el-gr",
         0x8A5745E2: "da-dk",
         0x1C549882: "pl-pl",
         0xA3B8B608: "it-it",
         0xB2596A82: "pt-br",
         0x195B5F2C: "fi-fi",
         0xE7297D92: "es-es",
         0x6286DF0E: "fr-fr",
         0x3DB57750: "de-de",
         0x7E80F152: "en-gb",
         0x253DD1D3: "sv-se",
         0xA4595492: "pt-pt",
         0x7080DB55: "en-us",
         0x5CB9F1B6: "nl-nl",
         0xF15488F8: "hu-hu",
         0x3299FB3B: "cs-cz",
         0xF7928B30: "no-no"}

def doAdvAchievements():
    pkg = package.DatabasePackedFile()
    achievements = {}
    stream = open("/Applications/Games/Simulation & Sports/SPORE/SPORE Galactic Adventures.app/Contents/Resources/transgaming/c_drive/SPORE_EP1/Data/Spore_EP1_Locale_01.package", 'rb')
    pkg.read(stream)
    for index in pkg.indices:
        innerPkg = package.DatabasePackedFile()
        stream.seek(index.offset)
        if index.compressed:
            innerStream = cStringIO.StringIO(''.join([chr(c) for c in package.refPackDecompress(stream, index.compressedSize, index.decompressedSize)]))
        else:
            innerStream = cStringIO.StringIO(stream.read(index.compressedSize))
        innerPkg.read(innerStream)
        for innerIndex in innerPkg.indices:
            if innerIndex.instanceId == 0x0AEC66642:
                break
        innerStream.seek(innerIndex.offset)
        if innerIndex.compressed:
            data = ''.join([chr(c) for c in package.refPackDecompress(innerStream, innerIndex.compressedSize, innerIndex.decompressedSize)])
        else:
            data = innerStream.read(innerIndex.compressedSize)
        innerStream.close()
        encoding = getEncoding(data[:4])
        data = data.decode(encoding)
        for line in data.splitlines():
            line = line.strip()
            line = line.replace(u'\ufeff', '')
            if len(line) == 0 or line[0] == '#':
                continue
            line = line.partition(' ')
            id = int(line[0], 16)
            isTitle = id in titles
            if id == 0x07f460b4:
                id = 0x07f46071
            elif id == 0x07c8fc40:
                id = 0x07c8fc38
            elif id == 0x07c8fcea:
                id = 0x07c8fcee
            elif id == 0x0770B802: # ADV - short for adventure (not an achievement)
                continue
            info = line[2]
            info = info.replace('~br~', '\n')
            achievement = {}
            if isTitle:
                achievement["name"] = info
                achievement["id"] = id
                if achievements.has_key(id):
                    achievements[id].update(achievement)
                else:
                    achievements[id] = achievement
            else:
                achievement["description"] = info
                if achievements.has_key(id-1):
                    achievements[id-1].update(achievement)
                else:
                    achievements[id-1] = achievement
        writeXML(langs[index.instanceId]+"-adv.xml", encoding, achievements, "0xaec66642")
        writePlist(langs[index.instanceId]+"-adv.plist", achievements, "0xaec66642")
    stream.close()

def doSporeAchievements():
    achievements = {}
    for locale in os.listdir(basedir):
        stream = open(basedir+locale+"/Text.package", 'rb')
        pkg = package.DatabasePackedFile()
        pkg.read(stream)
        for index in pkg.indices:
            if index.groupId == 0x00000000 \
               and index.typeId == 0x02FAC0B6 \
               and index.instanceId == 0x0CC8B2C9:
                break
        stream.seek(index.offset)
        if index.compressed:
            data = ''.join([chr(c) for c in package.refPackDecompress(stream, index.compressedSize, index.decompressedSize)])
        else:
            data = stream.read(index.compressedSize)
        stream.close()
        encoding = getEncoding(data[:4])
        data = data.decode(encoding)
        for line in data.splitlines():
            if len(line) == 0:
                continue
            elif line[0] == '#':
                if line.endswith('itle'): title = True
                else: title = False
                fname = line[1:line.find(' ', 2)]
                fname = fname.strip()
                fname = fname.lower()
                if fname == "spg-gopher.prop":
                    fname = "spg-questmaster.prop"
                continue
            line = line.partition(' ')
            id = int(line[0], 16)
            info = line[2]
            info = info.replace('~br~', '\n')
            achievement = {}
            if title:
                achievement["name"] = info
                achievement["id"] = id
            else:
                achievement["description"] = info
            if achievements.has_key(fname):
                achievements[fname].update(achievement)
            else:
                achievements[fname] = achievement
        writeXML(locale+"-csa.xml", encoding, achievements, "0x0cc8b2c9")
        writePlist(locale+"-csa.plist", achievements, "0x0cc8b2c9")

def mergeXML(basePath):
    csa = open(basePath+"-csa.xml", 'rb').read()
    adv = open(basePath+"-adv.xml", 'rb').read()
    result = "<achievements>\n"+csa[18:-15]+'\n'+adv[18:-15]+"</achievements>"
    open(basePath+".xml", 'wb').write(result)

def mergePlist(basePath):
    csa = plistlib.readPlist(basePath+"-csa.plist")
    adv = plistlib.readPlist(basePath+"-adv.plist")
    result = {}
    result.update(csa)
    result.update(adv)
    plistlib.writePlist(result, basePath+".plist")

def mergeAll():
    for locale in langs.itervalues():
        basePath = savePrefix+locale
        if os.path.exists(basePath+"-adv.xml"):
            mergeXML(basePath)
        if os.path.exists(basePath+"-adv.plist"):
            mergePlist(basePath)
        
if __name__ == "__main__":
    doSporeAchievements()
    doAdvAchievements()
    mergeAll()
